import java.util.*;
public class Node {
    int id;
    boolean fixed;
    int weight;
    Node via;
    Vector<Edge> edges;
    public Node(int id) {
	this.id = id;
	this.fixed = false;
	this.weight = Integer.MAX_VALUE;
	this.via = null;
	this.edges = new Vector<Edge>();
    }
    public int getId() { return id; }
    public void setId(int id) { this.id = id; }
    public String toString() {
	return "node#"+id+":"+weight+":"+fixed +":"+edges;
    }
    public static String toString(Node[] a) {
	StringBuffer sb = new StringBuffer();
	sb.append("[");
	for (int i=0; i<a.length; i++) sb.append(a[i] + " ");
	sb.append("]");
	return sb.toString();
    }
    public boolean isFixed() { return fixed; }
    public void setFixed() { this.fixed = true; }
    public int getWeight() { return weight; }
    public void setWeight(int w) { this.weight = w; }
    public Node getVia() { return via; }
    public void setVia(Node via) { this.via = via; }
    public static Node linearSearch(int id,Node[] nodes) {
	for (int i=0; i<nodes.length; i++)
	    if (nodes[i].getId() == id) return nodes[i];
	return null;
    }
    public void addEdge(Node dst,int weight) {
	Edge e = new Edge(this,dst,weight);
	edges.add(e);
    }
    public static void sort(Node[] a) {
	for (int i=0; i<a.length -1; i++) {
	    int k=i;
	    for (int j=i+1; j<a.length; j++)
		if (a[k].getId() > a[j].getId()) k = j;
	    Node tmp = a[i]; a[i] = a[k]; a[k] = tmp;
	}
    }
    public static void sort(Vector<Node> v) {
	for (int i=0; i<v.size() -1; i++) {
	    int k=i;
	    for (int j=i+1; j<v.size(); j++)
		if (v.elementAt(k).getId() > v.elementAt(j).getId()) k = j;
	    Node tmp = v.elementAt(i);
	    v.setElementAt(v.elementAt(k),i);
	    v.setElementAt(tmp,k);
	}
    }
    public static Node binarySearch(int id,Node[] nodes) {
	int low = 0;
	int high = nodes.length - 1;
	while (low <= high) {
	    int mid = (low + high) / 2;
	    int x = nodes[mid].getId();
	    if (x == id) return nodes[mid];
	    if (id < x) high = mid - 1;
	    else low = mid + 1;
	}
	return null;
    }
    public static Node linearSearch(int id,Vector<Node> v) {
	for (int i=0; i<v.size(); i++) {
	    Node node = v.elementAt(i);
	    if (node.getId() == id) return node;
	}
	return null;
    }
    public static Node binarySearch(int id,Vector<Node> v) {
	int low = 0;
	int high = v.size() - 1;
	while (low <= high) {
	    int mid = (low + high) / 2;
	    Node node = v.elementAt(mid);
	    int x = node.getId();
	    if (x == id) return node;
	    if (id < x) high = mid - 1;
	    else low = mid + 1;
	}
	return null;
    }
}
